// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles
parcelRequire = (function (modules, cache, entry, globalName) {
  // Save the require from previous bundle to this closure if any
  var previousRequire = typeof parcelRequire === 'function' && parcelRequire;
  var nodeRequire = typeof require === 'function' && require;

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire = typeof parcelRequire === 'function' && parcelRequire;
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error('Cannot find module \'' + name + '\'');
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = cache[name] = new newRequire.Module(name);

      modules[name][0].call(module.exports, localRequire, module, module.exports, this);
    }

    return cache[name].exports;

    function localRequire(x){
      return newRequire(localRequire.resolve(x));
    }

    function resolve(x){
      return modules[name][1][x] || x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [function (require, module) {
      module.exports = exports;
    }, {}];
  };

  var error;
  for (var i = 0; i < entry.length; i++) {
    try {
      newRequire(entry[i]);
    } catch (e) {
      // Save first error but execute all entries
      if (!error) {
        error = e;
      }
    }
  }

  if (entry.length) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(entry[entry.length - 1]);

    // CommonJS
    if (typeof exports === "object" && typeof module !== "undefined") {
      module.exports = mainExports;

    // RequireJS
    } else if (typeof define === "function" && define.amd) {
     define(function () {
       return mainExports;
     });

    // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }

  // Override the current require with this new one
  parcelRequire = newRequire;

  if (error) {
    // throw error from earlier, _after updating parcelRequire_
    throw error;
  }

  return newRequire;
})({"../../../../../../../../../../aws-sdk.external":[function(require,module,exports) {
module.exports=require('aws-sdk');
},{}],"index.ts":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handler = void 0;

const aws_sdk_1 = require("aws-sdk");

const codeDeploy = new aws_sdk_1.CodeDeploy();

const getProperties = props => ({
  applicationName: props.ApplicationName,
  deploymentGroupName: props.DeploymentGroupName,
  serviceRoleArn: props.ServiceRoleArn,
  ecsServices: props.EcsServices.map(({
    ClusterName,
    ServiceName
  }) => ({
    clusterName: ClusterName,
    serviceName: ServiceName
  })),
  targetGroupNames: props.TargetGroupNames,
  prodTrafficListenerArn: props.ProdTrafficListenerArn,
  testTrafficListenerArn: props.TestTrafficListenerArn,
  terminationWaitTimeInMinutes: props.TerminationWaitTimeInMinutes,
  autoRollbackOnEvents: props.AutoRollbackOnEvents
});

const onCreate = async event => {
  const {
    applicationName,
    deploymentGroupName,
    serviceRoleArn,
    ecsServices,
    targetGroupNames,
    prodTrafficListenerArn,
    testTrafficListenerArn,
    terminationWaitTimeInMinutes,
    autoRollbackOnEvents
  } = getProperties(event.ResourceProperties);
  await codeDeploy.createDeploymentGroup({
    applicationName,
    deploymentGroupName,
    serviceRoleArn,
    ecsServices,
    loadBalancerInfo: {
      targetGroupPairInfoList: [{
        prodTrafficRoute: {
          listenerArns: [prodTrafficListenerArn]
        },
        testTrafficRoute: {
          listenerArns: [testTrafficListenerArn]
        },
        targetGroups: targetGroupNames.map(name => ({
          name
        }))
      }]
    },
    autoRollbackConfiguration: {
      enabled: !!autoRollbackOnEvents,
      events: autoRollbackOnEvents
    },
    blueGreenDeploymentConfiguration: {
      terminateBlueInstancesOnDeploymentSuccess: {
        action: 'TERMINATE',
        terminationWaitTimeInMinutes
      },
      deploymentReadyOption: {
        actionOnTimeout: 'CONTINUE_DEPLOYMENT'
      }
    },
    deploymentStyle: {
      deploymentType: 'BLUE_GREEN',
      deploymentOption: 'WITH_TRAFFIC_CONTROL'
    }
  }).promise();
  return {
    PhysicalResourceId: deploymentGroupName
  };
};

const onUpdate = async event => {
  const newProps = getProperties(event.ResourceProperties);
  const oldProps = getProperties(event.OldResourceProperties);
  await codeDeploy.updateDeploymentGroup({
    applicationName: oldProps.applicationName,
    currentDeploymentGroupName: oldProps.deploymentGroupName,
    newDeploymentGroupName: newProps.deploymentGroupName,
    ecsServices: newProps.ecsServices,
    loadBalancerInfo: {
      targetGroupPairInfoList: [{
        prodTrafficRoute: {
          listenerArns: [newProps.prodTrafficListenerArn]
        },
        testTrafficRoute: {
          listenerArns: [newProps.testTrafficListenerArn]
        },
        targetGroups: newProps.targetGroupNames.map(name => ({
          name
        }))
      }]
    },
    autoRollbackConfiguration: {
      enabled: !!newProps.autoRollbackOnEvents,
      events: newProps.autoRollbackOnEvents
    },
    blueGreenDeploymentConfiguration: {
      terminateBlueInstancesOnDeploymentSuccess: {
        action: 'TERMINATE',
        terminationWaitTimeInMinutes: newProps.terminationWaitTimeInMinutes
      },
      deploymentReadyOption: {
        actionOnTimeout: 'CONTINUE_DEPLOYMENT'
      }
    }
  }).promise();
  return {
    PhysicalResourceId: newProps.deploymentGroupName
  };
};

const onDelete = async event => {
  const {
    applicationName,
    deploymentGroupName
  } = getProperties(event.ResourceProperties);
  await codeDeploy.deleteDeploymentGroup({
    applicationName,
    deploymentGroupName
  }).promise();
};

exports.handler = async event => {
  const requestType = event.RequestType;

  switch (requestType) {
    case 'Create':
      return onCreate(event);

    case 'Update':
      return onUpdate(event);

    case 'Delete':
      return onDelete(event);

    default:
      throw new Error(`Invalid request type: ${requestType}`);
  }
};
},{"aws-sdk":"../../../../../../../../../../aws-sdk.external"}]},{},["index.ts"], null)
//# sourceMappingURL=/index.js.map